function RequestBroker(){
this.httpReq=null;
this.onSuccess=null;
this.onError=null;
this._body=null;
this._method="GET";
this._contentType=null;
};
RequestBroker.prototype.startAsync=function(_1){
this.cancel();
this.url=_1;
this.httpReq=new XMLHttpRequest();
if(RequestBroker.log.isInfoEnabled()){
RequestBroker.log.info("Fetching data from "+_1);
}
var _2=this;
this.httpReq.onreadystatechange=function(){
_2.readyStateChanged();
};
this.canceled=false;
this.httpReq.open(this._method,_1,true);
if(this._contentType){
this.httpReq.setRequestHeader("Content-Type",this._contentType);
}
this.httpReq.send(this._body);
};
RequestBroker.prototype.setMethod=function(_3){
this._method=_3;
};
RequestBroker.prototype.setBody=function(_4){
this._body=_4;
};
RequestBroker.prototype.setContentType=function(_5){
this._contentType=_5;
};
RequestBroker.prototype.cancel=function(){
this.canceled=true;
try{
if(this.httpReq){
this.httpReq.abort();
this.httpReq.onreadystatechange=function(){
};
}
}
catch(ex){
RequestBroker.log.warn("cancel failed.",ex);
}
};
RequestBroker.prototype.readyStateChanged=function(){
if(this.httpReq.readyState==4){
var _6=null;
try{
_6=this.httpReq.status;
}
catch(noStatusException){
RequestBroker.log.warn("No status specified in response.",noStatusException);
}
if(RequestBroker.log.isDebugEnabled()){
RequestBroker.log.debug("Got response with status "+_6+" "+this.httpReq.statusText);
}
if(this.canceled){
return;
}
var _7=this.httpReq;
this.httpReq=null;
if(_6==200){
var _8=_7.responseText;
if(_7.responseXML==null&&_8!=null&&_8.toLowerCase().indexOf("meta http-equiv=\"refresh\"")!=-1){
this.startAsync(this.url);
return;
}
try{
this.onSuccess.call(this,_7);
}
catch(err){
RequestBroker.log.error("Processing response failed.",err);
}
}else{
this.onError.call(this,_6);
}
_7=null;
}
};
RequestBroker.log=Logger.getLogger("RequestBroker");
function JsonRequestBroker(){
this.broker=new RequestBroker();
var _9=this;
this.broker.onSuccess=function(_a){
_9._parseJson(_a);
};
this.broker.onError=function(_b){
_9.onError.call(_9,_b);
};
this.onSuccess=null;
this.onError=null;
this.response=null;
};
JsonRequestBroker.prototype.startAsync=function(_c){
this.broker.startAsync(_c);
};
JsonRequestBroker.prototype.cancel=function(){
this.broker.cancel();
};
JsonRequestBroker.prototype._parseJson=function(_d){
this.response=null;
try{
eval("this.response = "+_d.responseText);
}
catch(e){
JsonRequestBroker.log.error("Unexpected response from server: '"+_d.responseText+"'.",e);
}
if(this.response!=null){
this.onSuccess.call(this,this.response);
this.response=null;
}else{
this.onError.call(this,500);
}
};
JsonRequestBroker.log=Logger.getLogger("JsonRequestBroker");
