DynamicHeaderTable=function(_1,_2,_3,_4){
this._container=_1;
this._table=$(_2);
this._columnCollections=_3;
this._rows=[];
this._flags=DynamicHeaderTable.Flags.SHOW_ARROW;
this._lastColumnItem=_4;
this._createColumns();
};
DynamicHeaderTable.Flags={SHOW_ARROW:1};
DynamicHeaderTable.prototype._createColumn=function(_5,_6){
var _7=this._columnCollections[_5];
var td=document.createElement("td");
td.className=_6;
if(_7.count()>1){
td.innerHTML="<div class='title_change'>"+_7.getLabel()+"</div>";
var _9=this;
var l=this._container.add(td,this._lastColumnItem,null,this._lastColumnItem);
l.onclicked=function(){
_9._columnClicked(this,_5);
};
this._lastColumnItem=l;
}else{
td.innerHTML="<div class='title_change static'>"+_7.getLabel()+"</div>";
}
return td;
};
DynamicHeaderTable.prototype.setShowArrow=function(_b){
this._flags&=~DynamicHeaderTable.Flags.SHOW_ARROW;
if(_b){
this._flags|=DynamicHeaderTable.Flags.SHOW_ARROW;
}
};
DynamicHeaderTable.prototype.refreshHeader=function(_c){
this._columnPlaceholders[_c].firstChild.innerHTML=this._columnCollections[_c].getLabel();
};
DynamicHeaderTable.prototype._createColumns=function(){
this._columnPlaceholders=[];
var tr=document.createElement("tr");
tr.className="table_title";
var td=this._createColumn(0,"first");
this._columnPlaceholders.push(td);
tr.appendChild(td);
td=this._createColumn(1,"second");
this._columnPlaceholders.push(td);
tr.appendChild(td);
td=this._createColumn(2,"third");
this._columnPlaceholders.push(td);
tr.appendChild(td);
td=document.createElement("td","arrow");
this._columnPlaceholders.push(td);
tr.appendChild(td);
this._table.appendChild(tr);
};
DynamicHeaderTable.prototype._columnClicked=function(_f,_10){
var _11=this._columnCollections[_10];
_11.next();
_f.element.firstChild.innerHTML=_11.getLabel();
for(var i=0;i<this._rows.length;++i){
var row=this._rows[i];
if(row._item){
var _14=row.element.firstChild;
for(var j=0;_14&&j<_10;++j){
_14=_14.nextSibling;
}
if(_14){
_11.format(_14,row._item);
}
}
}
};
DynamicHeaderTable.prototype.getColumnCollection=function(_16){
return this._columnCollections[_16];
};
DynamicHeaderTable.prototype.addCustomRow=function(row,_18,_19,_1a){
if(_19==null){
_19=this._rows.length-1;
}
if(_1a==null){
_1a=true;
}
var _1b=(_19>=0)?this._rows[_19]:null;
var _1c=_1b;
while(_1c&&!_1c._focusable){
_1c=_1c.up;
}
if(!_1c){
_1c=this._lastColumnItem;
}
var _1d=this._container.add(row,_1c);
if(_18){
var obj=new Object();
for(var n in _18){
if(!_18.hasOwnProperty(n)){
continue;
}
var v=_18[n];
if(v.constructor===String){
obj[n]=new String(v);
}
}
_1d._item=obj;
}
_1d._focusable=_1a;
if(_1c==this._lastColumnItem){
this._container.activate(_1d);
}
if(!_1a&&!WrtHelper.isTouchEnabledDevice()){
if(_1d.up){
_1d.up.down=_1d.down;
}
if(_1d.down){
_1d.down.up=_1d.up;
}
}
this._rows.splice(_19+1,0,_1d);
if(_1b){
this._table.insertAfter(row,_1b.element);
}else{
this._table.appendChild(row);
}
return _1d;
};
DynamicHeaderTable.prototype.addRow=function(_21){
var row=this._createRow(_21);
return this.addCustomRow(row,_21);
};
DynamicHeaderTable.prototype.insertRow=function(_23,_24){
var row=this._createRow(_23);
return this.addCustomRow(row,_23,_24);
};
DynamicHeaderTable.prototype.removeRows=function(_26,_27){
for(var i=_26;i<_26+_27;++i){
this._container.remove(this._rows[i].id);
}
this._rows.splice(_26,_27);
};
DynamicHeaderTable.prototype.clearRows=function(){
this.removeRows(0,this._rows.length);
};
DynamicHeaderTable.prototype.getIndexOf=function(row){
for(var i=0;i<this._rows.length;++i){
if(this._rows[i]==row){
return i;
}
}
return -1;
};
DynamicHeaderTable.prototype._createRow=function(_2b){
var tr=document.createElement("tr");
tr.className="item";
var td=document.createElement("td");
td.className="first";
this._columnCollections[0].format(td,_2b);
tr.appendChild(td);
td=document.createElement("td");
this._columnCollections[1].format(td,_2b);
tr.appendChild(td);
td=document.createElement("td");
this._columnCollections[2].format(td,_2b);
tr.appendChild(td);
if(this._flags&DynamicHeaderTable.Flags.SHOW_ARROW){
td=document.createElement("td");
td.className="arrow";
td.innerHTML="<div class='stock_more'></div>";
tr.appendChild(td);
}else{
td.colSpan=2;
}
return tr;
};
DynamicHeaderTable.Column=function(_2e,_2f){
this._label=_2e;
this._formatter=_2f;
};
DynamicHeaderTable.Column.prototype.getLabel=function(){
return this._label;
};
DynamicHeaderTable.Column.prototype.format=function(td,_31){
this._formatter(td,_31);
};
DynamicHeaderTable.ColumnCollection=function(_32){
this._columns=_32;
this._selected=0;
};
DynamicHeaderTable.ColumnCollection.prototype.getColumn=function(){
return this._columns[this._selected];
};
DynamicHeaderTable.ColumnCollection.prototype.getLabel=function(){
return this.getColumn().getLabel();
};
DynamicHeaderTable.ColumnCollection.prototype.format=function(td,_34){
this.getColumn().format(td,_34);
};
DynamicHeaderTable.ColumnCollection.prototype.next=function(){
if(++this._selected>=this._columns.length){
this._selected=0;
}
};
DynamicHeaderTable.ColumnCollection.prototype.count=function(){
return this._columns.length;
};
DynamicHeaderTable.ColumnCollection.prototype.clear=function(){
this._selected=0;
this._columns=[];
};
DynamicHeaderTable.ColumnCollection.prototype.add=function(_35){
this._columns.push(_35);
};
