function GraphDetails(){
GraphDetails.baseConstructor.call(this,"chart_full");
this.graphs=[];
this.graphs[GraphDetails.ONE_YEAR]=this.createGraph("chart_full_placeholder_one_year");
this.graphs[GraphDetails.ONE_MONTH]=this.createGraph("chart_full_placeholder_one_month");
this.graphs[GraphDetails.SIX_MONTH]=this.createGraph("chart_full_placeholder_six_month");
this.graphs[GraphDetails.ONE_DAY]=this.createGraph("chart_full_placeholder_day");
this.graphs[GraphDetails.FIVE_YEARS]=this.createGraph("chart_full_placeholder_five_years");
var _1=this;
this._buttons=[];
this._buttons[GraphDetails.ONE_YEAR]=this.add("btn_one_year");
this.btnValues=this.add("chart_full_btn",null,this._buttons[GraphDetails.ONE_YEAR]);
this.btnValues.onclicked=function(){
_1.onValuesBtnClicked();
};
this._buttons[GraphDetails.SIX_MONTH]=this.add("btn_six_months",this.btnValues,null,null,this._buttons[GraphDetails.ONE_YEAR]);
this._buttons[GraphDetails.ONE_MONTH]=this.add("btn_one_month",this.btnValues,null,null,this._buttons[GraphDetails.SIX_MONTH]);
this._buttons[GraphDetails.FIVE_YEARS]=this.add("btn_five_years",this.btnValues,null,this._buttons[GraphDetails.ONE_YEAR],null);
this._buttons[GraphDetails.ONE_DAY]=this.add("btn_one_day",this.btnValues,null,null,this._buttons[GraphDetails.ONE_MONTH]);
this._buttons[GraphDetails.ONE_DAY].onclicked=function(){
_1.oneDay();
};
this._buttons[GraphDetails.ONE_MONTH].onclicked=function(){
_1.oneMonth();
};
this._buttons[GraphDetails.SIX_MONTH].onclicked=function(){
_1.sixMonth();
};
this._buttons[GraphDetails.ONE_YEAR].onclicked=function(){
_1.oneYear();
};
this._buttons[GraphDetails.FIVE_YEARS].onclicked=function(){
_1.fiveYears();
};
this.updateManager=new BAsyncJob(new XmlRequestBroker());
this.updateManager.onSuccess=function(_2){
setTimeout(function(){
_1.onReceivedValues(_2);
},0);
};
this.updateManager.onError=function(_3){
GraphDetails.log.warn("Unable to read values: "+_3);
};
if(WrtHelper.isTouchEnabledDevice()){
var _1=this;
this.graphs[0].setResizeHandler(function(){
if(_1.isActive()&&WrtHelper.screenHeight()>WrtHelper.screenWidth()){
_1.onBackSoftMenu();
}
});
if(!this._backHandlerBtn){
this._backHandlerBtn=this.add("chart_full_back_btn");
this._backHandlerBtn.onclicked=function(){
_1.onBackSoftMenu();
};
}
}else{
this._injectMenuBtn(this._buttons[GraphDetails.ONE_DAY]);
for(var i=0;i<this._buttons.length;++i){
this._buttons[i].down=this.menu;
}
}
};
Helper.extend(GraphDetails,FormWithBack);
GraphDetails.prototype.updateBars=function(_5){
if(WrtHelper.isTouchEnabledDevice()){
var _6=WrtHelper.isLandscape();
var l=$("buttons_bottom_landscape");
var m=$("menu");
if(_5){
l.show(_6);
m.show(!_6);
}else{
l.show(false);
m.show(false);
}
}
$("overflow").show(_5);
};
GraphDetails.prototype.onActivated=function(){
AppStats.inc(AppStats.AppId.GRAPH_VIEW);
this.updateBars(false);
GraphDetails.base.onActivated.call(this);
this._clearValues();
this._addValue(StringTable.GraphDetails.Last);
this._addValue(StringTable.GraphDetails.Open);
this._addValue(StringTable.GraphDetails.High);
this._addValue(StringTable.GraphDetails.Low);
this.onValuesBtnClicked();
this.updateManager.startAsync({path:"apps/wds/SecurityData.asp",query:{Securities:this.pxWBTKR,Outfields:"PR005,PR006,UTIME"}},null,true);
};
GraphDetails.prototype.onDeactivated=function(){
GraphDetails.base.onDeactivated.call(this);
this.updateBars(true);
this._clearGraphs();
};
GraphDetails.prototype.onReceivedValues=function(_9){
var _a=_9.pxMarketData[0].pxCalcrt[0].pxSecurity[0];
var _b=function(_c){
this._clearValues();
var _d=Utils.date2String(_a.pxUTIME);
if(_d.indexOf(":")===-1){
_d=GraphDetails._date2String(parseInt(_a.pxUTIME)*1000);
}else{
_d=StringTable.GraphDetails.At+" "+_d;
}
var hl=JSON.parse(_c.responseText);
this._addValue(StringTable.GraphDetails.Last,_a.pxPR005,_d);
this._addValue(StringTable.GraphDetails.Open,_a.pxPR006);
if(hl&&hl.high&&hl.low){
this._addValue(StringTable.GraphDetails.High,hl.high.value,GraphDetails._date2String(hl.high.time));
this._addValue(StringTable.GraphDetails.Low,hl.low.value,GraphDetails._date2String(hl.low.time));
}
this.onValuesBtnClicked();
};
var _f=new AsyncJob(new RequestBroker());
var _10=this;
_f.onSuccess=function(req){
_b.call(_10,req);
};
_f.onError=function(_12){
GraphDetails.log.warn("Unable to read values: "+_12);
};
var _13=GraphDetails.buildGraphUrl(this.pxWBTKR);
var _14=BAsyncJob.encodeObject(_13.query);
_f.startAsync(GraphBroker.SERVER_ADDRESS+"/BloomCharts/highlow?"+_14,null,true);
};
GraphDetails._date2String=function(_15){
if(_15.constructor===String){
_15=parseInt(_15);
}
var _16=new Date();
_16.setTime(_15);
var _17=_16.getFullYear().toString();
var _18=parseInt(_16.getMonth());
var _18=StringTable.Months[_18];
return StringTable.GraphDetails.On+" "+_16.getDate()+" "+_18+" "+_17.substring(2,4);
};
GraphDetails.prototype._clearValues=function(){
this._activeValue=-1;
this._values=[];
};
GraphDetails.prototype._addValue=function(_19,_1a,_1b){
this._values.push({name:_19,value:_1a||"-",date:_1b});
};
GraphDetails.prototype.onValuesBtnClicked=function(){
++this._activeValue;
if(this._activeValue>=this._values.length){
this._activeValue=0;
}
var _1c=this._values[this._activeValue];
$("chart_full_btn").innerHTML=_1c.name;
var _1d=_1c.value;
if(_1c.date){
_1d+=" <span class='date'> "+_1c.date+"</span>";
}
$("chart_full_btn_label").innerHTML=_1d;
var id=null;
switch(_1c.name){
case StringTable.GraphDetails.High:
id=AppStats.AppId.GRAPH_PRICE_HIGH;
break;
case StringTable.GraphDetails.Low:
id=AppStats.AppId.GRAPH_PRICE_LOW;
break;
case StringTable.GraphDetails.Last:
id=AppStats.AppId.GRAPH_PRICE_LAST;
break;
case StringTable.GraphDetails.Open:
id=AppStats.AppId.GRAPH_PRICE_OPEN;
break;
}
if(id){
AppStats.inc(id);
}else{
GraphDetails.log.error("Invalid id specified!");
}
};
GraphDetails.prototype.createGraph=function(_1f){
return new AreaChart(_1f);
};
GraphDetails.prototype.display=function(_20){
this.pxWBTKR=_20;
$("chart_full_ticker").innerHTML=_20;
this.parent.activate(this.id);
this._clearGraphs();
this.oneYear();
};
GraphDetails.prototype._clearGraphs=function(){
for(var i=0;i<this.graphs.length;++i){
var _22=this.graphs[i];
_22.init();
_22.fetched=false;
}
};
GraphDetails.buildGraphUrl=function(_23,_24){
var _25=GraphDetails.buildBasicGraphUrl(_23);
_25.query.TimePeriod=(_24||1)+"Y";
_25.query.Outfields="HDATE,PR005-H";
return _25;
};
GraphDetails.buildBasicGraphUrl=function(_26){
return {query:{pid:"webpxta",Securities:_26}};
};
GraphDetails.buildPerDayGraphUrl=function(_27){
var _28=GraphDetails.buildBasicGraphUrl(_27);
_28.query.Outfields="ITIME,PR005-I";
return _28;
};
GraphDetails.prototype._toggleBtn=function(_29){
for(var i=0;i<this._buttons.length;++i){
this._buttons[i].element.setClassName("toggle",i===_29);
}
};
GraphDetails.prototype.oneDay=function(){
AppStats.inc(AppStats.AppId.GRAPH_VIEW_ONE_DAY);
this.updateGraph(GraphDetails.ONE_DAY,GraphDetails.buildPerDayGraphUrl(this.pxWBTKR));
this._toggleBtn(GraphDetails.ONE_DAY);
};
GraphDetails.prototype.oneMonth=function(){
AppStats.inc(AppStats.AppId.GRAPH_VIEW_ONE_MONTH);
this.updateGraph(GraphDetails.ONE_MONTH,GraphDetails.buildGraphUrl(this.pxWBTKR),1);
this._toggleBtn(GraphDetails.ONE_MONTH);
};
GraphDetails.prototype.sixMonth=function(){
AppStats.inc(AppStats.AppId.GRAPH_VIEW_SIX_MONTHS);
this.updateGraph(GraphDetails.SIX_MONTH,GraphDetails.buildGraphUrl(this.pxWBTKR),6);
this._toggleBtn(GraphDetails.SIX_MONTH);
};
GraphDetails.prototype.oneYear=function(){
AppStats.inc(AppStats.AppId.GRAPH_VIEW_ONE_YEAR);
this.updateGraph(GraphDetails.ONE_YEAR,GraphDetails.buildGraphUrl(this.pxWBTKR));
this._toggleBtn(GraphDetails.ONE_YEAR);
};
GraphDetails.prototype.fiveYears=function(){
AppStats.inc(AppStats.AppId.GRAPH_VIEW_FIVE_YEARS);
this.updateGraph(GraphDetails.FIVE_YEARS,GraphDetails.buildGraphUrl(this.pxWBTKR,5));
this._toggleBtn(GraphDetails.FIVE_YEARS);
};
GraphDetails.prototype.showGraph=function(id,_2c){
if(GraphDetails.log.isDebugEnabled()){
GraphDetails.log.debug("Setting "+id+"->"+_2c);
}
$(this.graphs[id].placeholderId).show(_2c);
};
GraphDetails.prototype.updateGraph=function(id,_2e,_2f){
if(this.displayedGraphId!=null){
this.showGraph(this.displayedGraphId,false);
}
var _30=this.graphs[id];
if(!_30.fetched){
_30.fetched=true;
var _31="labels=true";
if(_2f){
_31+="&m="+_2f;
}
_30.startAsync(BAsyncJob.getQuery(_2e),_31);
}
this.displayedGraphId=id;
this.showGraph(this.displayedGraphId,true);
};
GraphDetails.ONE_YEAR=0;
GraphDetails.ONE_MONTH=1;
GraphDetails.SIX_MONTH=2;
GraphDetails.ONE_DAY=3;
GraphDetails.FIVE_YEARS=4;
GraphDetails.log=Logger.getLogger("GraphDetails");
