function IndustryMovers(){
IndustryMovers.baseConstructor.call(this,"industry_movers","overflow");
this.chartButton=this.add("industry_movers_chart_button");
this.tableButton=this.add("industry_movers_table_button",this.chartButton,null,this.chartButton);
var _1=this;
this.chartButton.onclicked=function(){
_1.switchView(IndustryMovers.CHART);
};
this.tableButton.onclicked=function(){
_1.switchView(IndustryMovers.TABLE);
};
this._initTable();
this.updateManager=new AsyncJob(new XmlRequestBroker());
this.updateManager.onSuccess=function(_2){
_1.onReceivedIndustryMovers(_2);
};
this.updateManager.onError=function(_3){
_1.handleErrorResponse(_3);
};
};
Helper.extend(IndustryMovers,FormWithBack);
IndustryMovers.prototype._initTable=function(){
var _4=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.IndustryMovers.Category,function(td,_6){
td.innerHTML=_6.getAttribute("group");
}),]);
var _7=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.IndustryMovers.Last,function(td,_9){
var _a=_9.getAttribute("current");
if(!_a){
_a="";
}
Utils.assignFormattedNumber(td,_a,2);
})]);
var _b=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.IndustryMovers.PercentChange,function(td,_d){
var _e=_d.getAttribute("current");
var _f=_d.getAttribute("last");
var _10=(_f&&_e)?(_e-_f)/_f*100:"";
Utils.assignFormattedNumber(td,_10,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES);
})]);
this._table=new DynamicHeaderTable(this,"industry_movers_table",[_4,_7,_b],this.tableButton);
};
IndustryMovers.prototype.handleErrorResponse=function(_11){
};
IndustryMovers.prototype.onReceivedIndustryMovers=function(_12){
var _13=(_12&&_12.data&&_12.data.length>0&&_12.data[0].item)?_12.data[0]:{item:[]};
this.selectedLevel=this.rootLevel=_13;
if(_13.item.length===0){
alert(StringTable.IndustryMovers.ClassificationInfoUnavail);
}
this.switchView(IndustryMovers.CHART);
};
IndustryMovers.prototype.showLevel=function(_14){
this.selectedLevel=_14;
this.clearScreen();
if(!_14||!_14.item){
return;
}
if(this.type==IndustryMovers.CHART){
this.showLevelGraph(_14);
}else{
this.showLevelTable(_14);
}
};
IndustryMovers.prototype.switchView=function(_15){
if(this.type==_15){
return;
}
this.type=_15;
var id=(_15==IndustryMovers.CHART)?AppStats.AppId.IMAP_CHART_VIEW:AppStats.AppId.IMAP_TABLE_VIEW;
AppStats.inc(id);
var _17=$("industry_movers_chart");
var _18=$("industry_movers_table");
_17.show(this.type==IndustryMovers.CHART);
_18.show(this.type==IndustryMovers.TABLE);
this.updateElementSelectedStatus(this.chartButton.element,this.chartButton==this.activeItem);
this.updateElementSelectedStatus(this.tableButton.element,this.tableButton==this.activeItem);
this.showLevel(this.selectedLevel);
};
IndustryMovers.prototype.showLevelGraph=function(_19){
this.chart=new PieChart("industry_movers_chart_placeholder");
if(!_19||!_19.item||!_19.item.length){
return;
}
var _1a="<?xml version='1.0'?><data";
var _1b=(_19===this.rootLevel)?this.pxWBTKR:_19.getAttribute("group");
_1a+=" group='"+_1b.replace(/&/g,"&amp;")+"'";
_1a+=">";
for(var i=1;i<=_19.item.length;++i){
if(i==IndustryMovers.MAX_ITEMS_PER_CHART&&i!=_19.item.length){
var _1d=0;
var _1e=0;
for(;i<=_19.item.length;++i){
var _1f=_19.item[i-1];
var _20=_1f.getAttribute("current");
var _21=_1f.getAttribute("last");
if(_21==null||_20==null){
continue;
}
_1d+=parseFloat(_20);
_1e+=parseFloat(_21);
}
_1a+="<item current='"+_1d+"' group='Others' last='"+_1e+"' />";
break;
}
var _1f=_19.item[i-1];
var _1b=_1f.getAttribute("group").replace(/&/g,"&amp;");
var _20=_1f.getAttribute("current");
var _21=_1f.getAttribute("last");
if(_20!=null&&_21!=null){
_1a+="<item current='"+_20+"' group='"+_1b+"' last='"+_21+"' />";
}
}
_1a+="</data>";
if(IndustryMovers.log.isDebugEnabled()){
IndustryMovers.log.debug("Request fot pie chart: "+_1a);
}
this.chart.startAsync(null,"data="+encodeURIComponent(_1a));
};
IndustryMovers.prototype.showLevelTable=function(_22){
var _23=this;
for(var i=0;i<_22.item.length;++i){
var _25=_22.item[i];
var row=this._table.addRow(_25);
row.index=i;
row.onclicked=function(){
_23.displaySublevel(this.index);
};
}
};
IndustryMovers.prototype.display=function(_27,_28){
this.pxWBTKR=_27;
$("industry_movers_title").innerHTML=_28;
this.parent.activate(this.id);
this.clearScreen();
this.type=null;
this.rootLevel=this.selectedLevel=null;
var _29=this.pxWBTKR.split(":")[0];
if(IndustryMovers.log.isDebugEnabled()){
IndustryMovers.log.debug("Loading industry movers for: "+_29);
}
var url=BAsyncJob.getQuery({path:GraphBroker.SERVER_ADDRESS+"/BloomCharts/movers",query:{Ticker:_29}});
this.updateManager.startAsync(url,this,true);
};
IndustryMovers.prototype.clearScreen=function(){
this._table.clearRows();
if(this.graphPlaceholder){
this.remove(this.graphPlaceholder.id,false);
this.graphPlaceholder=null;
}
this.removeInjectedMenuItems();
if(this.chart){
this.chart.init();
}
var _2b=this;
this.setScrollerPos(0);
if(WrtHelper.isTouchEnabledDevice()){
return;
}
if(this.type==IndustryMovers.CHART){
this.graphPlaceholder=this.add("industry_movers_chart",this.tableButton);
this.graphPlaceholder.onclicked=function(){
var _2c=_2b.chart.getSelectedIndex()+1;
if(_2c==IndustryMovers.MAX_ITEMS_PER_CHART&&_2c<_2b.selectedLevel.item.length){
_2b.switchView(IndustryMovers.TABLE);
}else{
_2b.displaySublevel(_2c-1);
}
};
this.activate(this.graphPlaceholder);
}
};
IndustryMovers.prototype.displaySublevel=function(_2d){
var _2e=this.selectedLevel.item[_2d];
var _2f=_2e.getAttribute("ticker");
if(_2f!=null){
var _30=this.parent.get("stocks_full");
_30.display(_2f);
}else{
_2e.parent=this.selectedLevel;
this.showLevel(_2e);
}
};
IndustryMovers.prototype.buildRequest=function(){
var _31=this.pxWBTKR.split(":")[0];
if(IndustryMovers.log.isDebugEnabled()){
IndustryMovers.log.debug("Loading industry movers for: "+_31);
}
return BAsyncJob.getQuery({query:{Ticker:_31,Outfields:"WBTKR,DS192,DS199,DS202,PR005,PR051",SortBy:"WBTKR"}});
};
IndustryMovers.prototype.onDeactivated=function(){
this.updateManager.cancel();
IndustryMovers.base.onDeactivated.call(this);
};
IndustryMovers.prototype._processKeyEvent=function(key){
if(this.activeItem==this.graphPlaceholder){
if(key==Keyboard.KEY_DOWN&&this.chart.next()){
return;
}
if(key==Keyboard.KEY_UP&&this.chart.prev()){
return;
}
}
switch(key){
case Keyboard.KEY_1:
this.activate(this.chartButton);
this.chartButton.onclicked();
break;
case Keyboard.KEY_2:
this.activate(this.tableButton);
this.tableButton.onclicked();
break;
default:
IndustryMovers.base._processKeyEvent.call(this,key);
break;
}
};
IndustryMovers.prototype.processBackButton=function(){
if(this.selectedLevel&&this.selectedLevel!=this.rootLevel){
this.showLevel(this.selectedLevel.parent);
}else{
IndustryMovers.base.processBackButton.call(this);
}
};
IndustryMovers.prototype.updateElementSelectedStatus=function(_33,_34){
if((_33.id=="industry_movers_chart_button")||(_33.id=="industry_movers_table_button")){
var _35=_33.className;
var _36="button_half";
if(_34){
_36+=" activated";
}
if((this.type==IndustryMovers.CHART&&_33.id=="industry_movers_chart_button")||(this.type==IndustryMovers.TABLE&&_33.id=="industry_movers_table_button")){
_36+=" toggle";
}
_33.className=_36;
}else{
IndustryMovers.base.updateElementSelectedStatus.call(this,_33,_34);
}
};
function onGraphPressed(_37){
var _38=WrtHelper.getSysInfo();
if(_38.startvibra){
_38.startvibra(10,10);
}
if(IndustryMovers.log.isDebugEnabled()){
IndustryMovers.log.debug("onGraphPressed: "+_37);
}
var _39=uiManager.get("industry_movers");
IndustryMovers.log.debug("onGraphPressed: "+_39);
if(_37==-1){
IndustryMovers.log.debug("Invoking back button on graph.");
if(_39.selectedLevel&&_39.selectedLevel!=_39.rootLevel){
_39.showLevel(_39.selectedLevel.parent);
}
return;
}
++_37;
if(_37==IndustryMovers.MAX_ITEMS_PER_CHART&&_37<_39.selectedLevel.item.length){
_39.switchView(IndustryMovers.TABLE);
}else{
_39.displaySublevel(_37-1);
}
};
IndustryMovers.CHART=0;
IndustryMovers.TABLE=1;
IndustryMovers.log=Logger.getLogger("IndustryMovers");
IndustryMovers.MAX_ITEMS_PER_CHART=6;
