function MiniView(){
MiniView.baseConstructor.call(this,"mini_view");
this.graph=new AreaChart("miniview_graph_placeholder",false);
this.graph.setProgressText(StringTable.Downloading,"miniview_downloader");
this.graphUpdateManager=new BAsyncJob(this.graph);
this.stockUpdateManager=new BAsyncJob(new XmlRequestBroker());
this.stockUpdateManager.enableCache();
this.stockUpdateManager.setCacheFilter(MyStocks._cacheFilter);
var _1=this;
this.stockUpdateManager.onSuccess=function(_2){
_1.onStockRefresh(_2);
};
this.stockUpdateManager.onError=function(_3){
_1.handleStockErrorResponse(_3);
};
this._stockList=null;
this._stockIndex=0;
this._showDownloadInProgress(false);
this._displayLastUpdateTime(" ");
};
Helper.extend(MiniView,Container);
MiniView.prototype._showDownloadInProgress=function(_4){
$("miniview_update_refreshing").show(_4);
$("miniview_update_done").show(!_4);
$("miniview_updated").setClassName("updating",_4);
};
MiniView.prototype.onActivated=function(){
MiniView.base.onActivated.call(this);
this._fetchStockData();
};
MiniView.prototype.update=function(){
if(this._stockList){
if(this._stockIndex<this._stockList.length){
this._displayStock(this._stockList[this._stockIndex]);
}
++this._stockIndex;
if(this._stockIndex>=this._stockList.length){
this._stockIndex=0;
}
this._fetchStockData();
}
};
MiniView.prototype._fetchStockData=function(){
if(this._lastUpdateTime.constructor===Date&&this._lastUpdateTime.getTime()+MiniView.UPDATE_INTERVAL>new Date().getTime()){
this._startUpdating();
return;
}
if(MiniView.log.isDebugEnabled()){
MiniView.log.debug("Refreshing mini view");
}
var _5={path:"apps/wds/SecurityData.asp",query:{Outfields:"WBTKR,PR005,PR007,PR008,UTIME",Securities:""}};
for(var i=0;i<MiniView.LIST.length;++i){
if(_5.query.Securities.length>0){
_5.query.Securities+=",";
}
_5.query.Securities+=MiniView.LIST[i];
}
this._showDownloadInProgress(true);
this.stockUpdateManager.startAsync(_5,null,true);
};
MiniView.prototype.handleStockErrorResponse=function(_7){
this._showDownloadInProgress(false);
this._displayLastUpdateTime(StringTable.NetworkError);
};
MiniView.prototype._displayLastUpdateTime=function(_8){
this._lastUpdateTime=_8||new Date();
var _9=(this._lastUpdateTime.constructor===Date)?Utils.formatLastUpdateTime(this._lastUpdateTime):this._lastUpdateTime;
$("miniview_updated").innerHTML=_9;
};
MiniView.prototype._displayStock=function(_a){
this.graph.init();
var _b=(_a.pxWBTKR.indexOf(":IND")!==-1);
var _c=$("miniview_icon_placeholder");
if(_b){
this.updateGraphData(_a.pxWBTKR);
}else{
var _d=_a.pxWBTKR.indexOf(":");
var _e="images/miniview/"+_a.pxWBTKR.substring(0,_d)+".png";
_c.src=_e;
}
_c.show(!_b);
$("miniview_graph_placeholder").show(_b);
$("mini_view_stocks_full_name").innerHTML=_a.pxWBTKR;
Utils.assignFormattedNumber($("mini_view_current_value"),_a.pxPR005,2,Utils.Format.TRIM_FRAC_ZERO);
Utils.assignFormattedNumber($("mini_view_day_high"),_a.pxPR007,3,Utils.Format.TRIM_FRAC_ZERO);
Utils.assignFormattedNumber($("mini_view_day_low"),_a.pxPR008,3,Utils.Format.TRIM_FRAC_ZERO);
$("mini_view_full_time").innerHTML=Utils.date2String(_a.pxUTIME);
};
MiniView.prototype.onStockRefresh=function(_f){
this._showDownloadInProgress(false);
this._displayLastUpdateTime();
this._stockList=_f;
this._startUpdating();
};
MiniView.prototype._startUpdating=function(){
if(this._stockList&&this._stockList.length>0&&this._intervalId==null){
var _10=this;
var _11=function(){
_10.update();
};
setTimeout(_11,0);
this._intervalId=setInterval(_11,10000);
}
};
MiniView.prototype.updateGraphData=function(_12){
this.graphUpdateManager._operationInProgress=false;
this.graphUpdateManager.startAsync(GraphDetails.buildPerDayGraphUrl(_12),null,true);
};
MiniView.prototype.onDeactivated=function(){
if(this._intervalId){
clearInterval(this._intervalId);
this._intervalId=null;
}
this.stockUpdateManager.cancel();
MiniView.base.onDeactivated.call(this);
};
MiniView.log=Logger.getLogger("MiniView");
MiniView.LIST=["CLA:COM","GOLDS:COM","INDU:IND","UKX:IND","DAX:IND","CAC:IND","NKY:IND","EUR:CUR","JPY:CUR","GBP:CUR"];
MiniView.UPDATE_INTERVAL=900*1000;
