function StockMovers(){
StockMovers.baseConstructor.call(this,"stock_movers","overflow");
this.updateManager=new BAsyncJob(new XmlRequestBroker());
var _1=this;
this.updateManager.onSuccess=function(_2){
_1.refreshDisplay(_2);
};
this.updateManager.onError=function(_3){
_1.handleErrorResponse(_3);
};
var _1=this;
this.leadersButton=this.add("stocks_movers_leaders");
this.leadersButton.onclicked=function(){
_1.switchView(StockMovers.LEADERS);
};
this.laggersButton=this.add("stocks_movers_laggers",this.leadersButton,null,this.leadersButton);
this.laggersButton.onclicked=function(){
_1.switchView(StockMovers.LAGGERS);
};
this._initTable();
};
Helper.extend(StockMovers,FormWithBack);
StockMovers.prototype._initTable=function(){
var _4=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.StockMovers.Stock,function(td,_6){
td.innerHTML=_6.pxDS192;
}),new DynamicHeaderTable.Column(StringTable.StockMovers.Ticker,function(td,_8){
td.innerHTML=_8.pxWBTKR;
}),]);
var _9=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.StockMovers.Last,function(td,_b){
Utils.assignFormattedNumber(td,_b.pxPR005,2);
})]);
var _c=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.StockMovers.PercentChange,function(td,_e){
Utils.assignFormattedNumber(td,_e.pxPR052,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES);
}),new DynamicHeaderTable.Column(StringTable.StockMovers.Change,function(td,_10){
Utils.assignFormattedNumber(td,_10.pxPR051,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES);
}),new DynamicHeaderTable.Column(StringTable.StockMovers.Time,function(td,_12){
td.className="";
td.innerHTML=Utils.date2String(_12.pxUTIME);
})]);
this._table=new DynamicHeaderTable(this,"stock_movers_table",[_4,_9,_c],this.laggersButton);
};
StockMovers.prototype.displayDetails=function(){
var _13=this.parent.get("stocks_full");
_13.display(this.activeItem.pxWBTKR);
};
StockMovers.prototype.handleErrorResponse=function(_14){
},StockMovers.prototype.refreshDisplay=function(xml){
if(!xml.pxMarketData[0].pxIndexMembers[0].pxSecurity){
if(StockMovers.log.isDebugEnabled()){
StockMovers.log.warn("Received an xml response with zero securities count.");
}
return;
}
if(xml.pxMarketData[0].pxIndexMembers[0].getAttribute("listset")=="Leaders"){
this.leaders=xml.pxMarketData[0].pxIndexMembers[0].pxSecurity;
this.laggers=xml.pxMarketData[0].pxIndexMembers[1].pxSecurity;
}else{
if(xml.pxMarketData[0].pxIndexMembers[0].getAttribute("listset")=="Laggers"){
this.leaders=xml.pxMarketData[0].pxIndexMembers[1].pxSecurity;
this.laggers=xml.pxMarketData[0].pxIndexMembers[0].pxSecurity;
}
}
this.switchView(StockMovers.LEADERS);
};
StockMovers.prototype.switchView=function(_16){
if(this.type==_16){
return;
}
var id=(_16==StockMovers.LEADERS)?AppStats.AppId.IMOV_LEADERS_VIEW:AppStats.AppId.IMOV_LAGGERS_VIEW;
AppStats.inc(id);
this.type=_16;
var _18=this;
this.clearScreen();
this.updateElementSelectedStatus(this.leadersButton.element,this.activeItem==this.leadersButton);
this.updateElementSelectedStatus(this.laggersButton.element,this.activeItem==this.laggersButton);
var _19=(_16==StockMovers.LEADERS?this.leaders:this.laggers);
if(_19==null){
return;
}
for(var i=0;i<_19.length;++i){
var _1b=_19[i];
var row=this._table.addRow(_1b);
row.pxWBTKR=_1b.pxWBTKR;
row.onclicked=function(){
_18.displayDetails();
};
}
};
StockMovers.prototype.display=function(_1d,_1e){
this.parent.activate(this.id);
$("stock_movers_title").innerHTML=_1e;
this.pxWBTKR=_1d;
this.type=null;
this.laggers=this.leaders=null;
this.clearScreen();
this.updateManager.startAsync(this.buildRequest(),this,true);
};
StockMovers.prototype.clearScreen=function(){
this._table.clearRows();
this.removeInjectedMenuItems();
this.setScrollerPos(0);
};
StockMovers.prototype.buildRequest=function(){
var _1f=this.pxWBTKR.split(":")[0];
if(StockMovers.log.isDebugEnabled()){
StockMovers.log.debug("Loading stock movers for: "+_1f);
}
return {path:"apps/wds/IndexMembers.asp",query:{Ticker:_1f,Outfields:"WBTKR,DS192,PR005,PR052,PR051,UTIME",Count:10,SortBy:"PR052"}};
};
StockMovers.prototype.onDeactivated=function(){
this.updateManager.cancel();
StockMovers.base.onDeactivated.call(this);
};
StockMovers.prototype.updateElementSelectedStatus=function(_20,_21){
if((_20.id=="stocks_movers_leaders")||(_20.id=="stocks_movers_laggers")){
var _22=_20.className;
var _23="button_half";
if(_21){
_23+=" activated";
}
if((this.type==StockMovers.LEADERS&&_20.id=="stocks_movers_leaders")||(this.type==StockMovers.LAGGERS&&_20.id=="stocks_movers_laggers")){
_23+=" toggle";
}
_20.className=_23;
}else{
StockMovers.base.updateElementSelectedStatus.call(this,_20,_21);
}
};
StockMovers.prototype._processKeyEvent=function(key){
switch(key){
case Keyboard.KEY_1:
this.activate(this.leadersButton);
this.leadersButton.onclicked();
break;
case Keyboard.KEY_2:
this.activate(this.laggersButton);
this.laggersButton.onclicked();
break;
default:
StockMovers.base._processKeyEvent.call(this,key);
break;
}
};
StockMovers.LEADERS=0;
StockMovers.LAGGERS=1;
StockMovers.log=Logger.getLogger("StockMovers");
