function GraphBroker(_1,_2){
this.placeholderId=_1;
if(_2==null){
_2=true;
}
this._autoResize=_2;
this._loaderMessageText=null;
};
GraphBroker.prototype.setProgressText=function(_3,_4){
this._loaderMessageText=_3;
this._loaderMessageClassName=_4;
};
GraphBroker.prototype.getValue=function(_5){
if(_5&&_5.length>2&&_5.substring(_5.length-2)=="px"){
_5=_5.substring(0,_5.length-2);
}
return parseInt(_5);
};
GraphBroker.prototype.getWidth=function(){
var _6=$(this.placeholderId);
return this.getValue(_6.style.width);
};
GraphBroker.prototype.getHeight=function(){
var _7=$(this.placeholderId);
return this.getValue(_7.style.height);
};
GraphBroker.prototype.startAsync=function(_8,_9){
var _a=GraphBroker.SERVER_ADDRESS+"/BloomCharts/";
_a+=this.getChartPath();
if(GraphBroker.log.isDebugEnabled()){
var _b=$(this.placeholderId);
GraphBroker.log.debug("Graph '"+_8+"' id: "+this.placeholderId+" placeholder width: "+_b.style.width+", placeholder height: "+_b.style.height);
}
_a+="?tz="+new Date().getTimezoneOffset();
if(_8!=null){
_a+="&"+_8;
}
if(_9!=null&&_9.length>0){
_a+="&"+_9;
}
if(!this.created){
var _c=this;
if(this._autoResize){
window.addEventListener("resize",function(e){
_c.onResize(e);
},false);
}
var _e="<div style='z-index: 1; position: absolute;'>";
if(this._loaderMessageText){
_e+="<span ";
if(this._loaderMessageClassName){
_e+="class='"+this._loaderMessageClassName+"'";
}else{
_e+="style='position: absolute;'";
}
_e+=">"+this._loaderMessageText;
+"</span>";
}else{
_e+="<img src='images/graph_loader.gif' style='width: "+GraphBroker.LOADER_WIDTH+"px; height: "+GraphBroker.LOADER_HEIGHT+"px; position: absolute;' />";
}
_e+="</div>";
_e+="<div style='z-index: 3; color: #FFF; padding: "+GraphBroker.PADDING+"px;"+" padding-top:"+GraphBroker.PADDING_TOP+"px; font-size: 18px; font-weight: bold;"+" text-align: center; position: absolute; background: url(images/shadow.png);"+" visibility:hidden;'></div>";
_e+="<div id='"+this.placeholderId+"_container' style='z-index: 2; position: relative;'></div>";
var _b=$(this.placeholderId);
_b.innerHTML=_e;
this.created=true;
this.centerProgressBar();
}
this.fetchWithUrl(_a);
};
GraphBroker.prototype.cancel=function(){
};
GraphBroker.prototype.showMessage=function(_f,_10){
var _11=this.getMessagePlaceholder();
if(_11){
_11.innerHTML=_f;
_11.style.visibility="visible";
setTimeout(function(){
_11.style.visibility="hidden";
},_10);
}
};
GraphBroker.prototype.getMessagePlaceholder=function(){
var _12=$(this.placeholderId).firstChild;
return (_12)?_12.nextSibling:null;
};
GraphBroker.prototype.fetchWithUrl=function(_13){
this.url=_13;
var _14=this.getHeight();
var _15=this.getWidth();
_13+="&width="+_15;
_13+="&height="+_14;
var _16=$(this.placeholderId+"_container");
this.injectGraph(_16,_13);
};
GraphBroker.log=Logger.getLogger("GraphBroker");
GraphBroker.LOADER_WIDTH=56;
GraphBroker.LOADER_HEIGHT=21;
GraphBroker.PADDING_TOP=30;
GraphBroker.PADDING=5;
GraphBroker.prototype.onResize=function(){
if(this.created){
this.clearGraph();
this.centerProgressBar();
if(this.url){
this.fetchWithUrl(this.url);
}
}
};
GraphBroker.prototype.setResizeHandler=function(_17){
this.onResize=_17;
};
GraphBroker.prototype.getResizeHandler=function(){
return this.onResize;
};
GraphBroker.prototype.centerProgressBar=function(){
var _18=this.getHeight();
var _19=this.getWidth();
var _1a=$(this.placeholderId);
var _1b=_1a.firstChild;
var _1c=_1b.firstChild;
if(_1c&&!this._loaderMessageClassName){
var _1d=(_18/2)-(GraphBroker.LOADER_HEIGHT/2);
var _1e=(_19/2)-(GraphBroker.LOADER_WIDTH/2);
_1c.style.top=_1d+"px";
_1c.style.left=_1e+"px";
}
var _1f=_1b.nextSibling;
if(_1f){
_1f.style.height=(_18-GraphBroker.PADDING-GraphBroker.PADDING_TOP)+"px";
_1f.style.width=(_19-2*GraphBroker.PADDING)+"px";
}
};
GraphBroker.prototype.init=function(){
this.url=null;
this.clearGraph();
};
GraphBroker.prototype.clearGraph=function(){
if(this.created){
var _20=$(this.placeholderId+"_container");
while(_20.firstChild){
var _21=_20.firstChild;
if(_21.tagName&&_21.tagName==="IMG"){
_21.onerror=_21.onload=null;
_21.src="foo";
}
_21.parentNode.removeChild(_21);
}
}
};
GraphBroker.prototype.injectGraph=function(_22,url){
var _24=document.createElement("img");
_24.onload=function(){
};
var _25=this;
_24.onerror=function(){
_25.init();
Utils.updateStatusLabelError();
};
_24.src=url;
_22.appendChild(_24);
};
GraphBroker.SERVER_ADDRESS="http://m.bloomberg.com";
function AreaChart(_26){
AreaChart.baseConstructor.call(this,_26);
};
Helper.extend(AreaChart,GraphBroker);
AreaChart.prototype.getChartPath=function(){
return "chart";
};
function PieChart(_27){
PieChart.baseConstructor.call(this,_27);
this.selected=0;
};
Helper.extend(PieChart,GraphBroker);
PieChart.prototype.getChartPath=function(){
return "pie";
};
if(!PieChart._isInitialized){
PieChart._isInitialized=true;
window.addEventListener("load",function(){
if(!WrtHelper.isTouchEnabledDevice()){
PieChart.prototype.injectGraph=function(_28,url){
_28.style.overflow="hidden";
PieChart.base.injectGraph.call(this,_28,url);
};
PieChart.prototype.fetchWithUrl=function(url){
this.select(0);
PieChart.base.fetchWithUrl.call(this,url);
};
PieChart.prototype.select=function(_2b){
var _2c=$(this.placeholderId+"_container");
var _2d=_2b*this.getWidth();
_2c.scrollLeft=_2d;
this.selected=_2b;
};
PieChart.prototype.getSelectedIndex=function(){
return this.selected;
};
PieChart.prototype.next=function(){
var _2e=$(this.placeholderId+"_container");
if(_2e&&_2e.firstChild){
var _2f=_2e.firstChild.width/this.getWidth()-1;
if(this.selected<_2f){
this.select(this.selected+1);
return true;
}
}
return false;
};
PieChart.prototype.prev=function(){
if(this.selected>0){
this.select(this.selected-1);
return true;
}
return false;
};
}else{
PieChart._mapIdCntr=1;
PieChart.prototype.injectGraph=function(_30,url){
if(!this._jsonBroker){
this._jsonBroker=new JsonRequestBroker();
var _32=this;
var _33=_30;
this._jsonBroker.onSuccess=function(obj){
var end=obj.chart.length-1;
while(end>0&&obj.chart.charAt(end)=="="){
--end;
}
if(end>0){
var map=document.createElement("map");
map.name=_32.placeholderId+"_map"+PieChart._mapIdCntr;
PieChart._mapIdCntr++;
var _37="";
for(var i=0;i<obj.spots.length;++i){
_37+="<area shape='polygon' coords='"+obj.spots[i].polygon+"'";
if(i<obj.spots.length-1){
_37+=" href='javascript:onGraphPressed("+i+");' />";
}else{
_37+=" href='javascript:onGraphPressed(-1);' />";
}
}
map.innerHTML=_37;
var url="data:image/png;base64,"+obj.chart.substring(0,end);
PieChart.base.injectGraph.call(_32,_33,url);
_33.firstChild.useMap="#"+map.name;
_33.appendChild(map);
}
};
this._jsonBroker.onError=function(_3a){
Utils.updateStatusLabelError();
};
}
url+="&touch=true&base64";
this._jsonBroker.startAsync(url);
};
}
},false);
}
PieChart.log=Logger.getLogger("PieChart");
